#!/usr/bin/env python3

import subprocess
import sys

def main():
    median()
    avg()

def median():
    cases = [
        ('colour.png', '[255, 0, 0, 255]'),
        ('palette.png', '[255, 153, 153, 255]'),
        ('ramp.png', '[0, 0, 0, 255]'),
    ]

    run("./median_colour_buggy.py", cases)

def avg():
    cases = [
        ('colour.png', '[64, 64, 64, 255]'),
        ('palette.png', '[170, 119, 119, 255]'),
        ('ramp.png', '[127, 127, 127, 255]'),
    ]

    run("./avg_colour_buggy.py", cases)

def run(program, cases):
    print("testing {}".format(program))
    for case in cases:
        filename = case[0]
        expected = "{}: {}".format(filename, case[1])

        result = subprocess.run([program, filename], capture_output=True)
        output = result.stdout.decode("utf-8").strip()

        if output == expected:
            print("    {} ok".format(filename))
        else:
            print("    {} ERROR\n    expected: {}\n    received: {}".format(filename, expected, output))



if __name__ == '__main__':
    main()
